<script lang="ts">
  import { onMount, onDestroy } from 'svelte';
  import {
    Collapse,
    Navbar,
    NavbarToggler,
    NavbarBrand,
    Nav,
    NavItem,
    NavLink,
    Dropdown,
    DropdownToggle,
    DropdownMenu,
    DropdownItem,
  } from 'sveltestrap';
  import { KeycloakStore, KeycloakInterface } from '@auth/keycloak';
  import type { Team } from '@models/Team';
  import type { EventConfiguration, EventConfigurationReturn } from '@models/EventConfigurations';
  import Countdown from './Countdown.svelte';
  import { EventRole } from '@auth/models';
  import { Gql } from '../db';
  import { AllEventCfgQuery } from '@models/EventConfigurations';

  let isOpen = false;
  let eventCfg: EventConfiguration | null = null;
  // On login, Redirect to referer if defined (ex, unauthorized page), otherwise redirect to current location
  const loginRedirect = new URL(window.location).searchParams.get('referer') || window.location.pathname;

  let team: Team | undefined;
  let authenticated: boolean = false;
  let keycloak: KeycloakInterface | undefined;

  let timerText = 'Time is up!';
  let timerEnd = new Date(0);

  const EventSink = {
    complete: () => console.warn('Event Sink Completed'),
    error: (err: unknown) => console.error(err),
    next: (value: { data: EventConfigurationReturn }) => {
      eventCfg = value.data.events[0]; // todo unsafe index
    },
  };

  onMount(() => {
    Gql.subscribe(`subscription ${AllEventCfgQuery}`, EventSink);
  });

  KeycloakStore.subscribe((value) => {
    keycloak = value.keycloak;
    authenticated = !!value.keycloak?.authenticated;
  });

  async function updateTimer() {
    const now = Date.now();
    if (now < Date.parse(eventCfg.event_open)) {
      timerText = 'Event opens in';
      timerEnd = new Date(eventCfg.event_open);
    } else if (now < Date.parse(eventCfg.start)) {
      timerText = 'Scoring starts in';
      timerEnd = new Date(eventCfg.start);
    } else if (now < Date.parse(eventCfg.break_start)) {
      timerText = 'Scoring break in';
      timerEnd = new Date(eventCfg.break_start);
    } else if (now < Date.parse(eventCfg.break_end)) {
      timerText = 'Scoring break over in';
      timerEnd = new Date(eventCfg.break_end);
    } else if (now < Date.parse(eventCfg.end)) {
      timerText = 'Active scoring over in';
      timerEnd = new Date(eventCfg.end);
    } else if (now < Date.parse(eventCfg.event_close)) {
      timerText = 'Event is over in';
      timerEnd = new Date(eventCfg.event_close);
    } else {
      timerText = 'Event is over, go home!';
      timerEnd = new Date(0);
    }
    setTimeout(() => {
      updateTimer();
    }, timerEnd.valueOf() - now);
  }

  function handleUpdate(event) {
    isOpen = event.detail.isOpen;
  }
</script>

<Navbar expand="md" class="custom-navbar">
  {#if eventCfg != null}
    {#key timerEnd}
      <Countdown id="nav-countdown" hovertext={timerText} placement="bottom" endtime={timerEnd} size={8} />
    {/key}
  {/if}
  <NavbarBrand href={eventCfg ? eventCfg.org_link : '/'}>{eventCfg ? eventCfg.name : 'Hackathon'}</NavbarBrand>
  <NavbarToggler on:click={() => (isOpen = !isOpen)} />
  <Collapse {isOpen} navbar expand="md" on:update={handleUpdate}>
    <Nav class="mr-auto" navbar>
      <NavItem>
        <NavLink class="link-underline" href="/">Home</NavLink>
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/dashboard">Dashboard</NavLink>
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/scoreboard">Scoreboard</NavLink>
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/challenges">Challenges</NavLink>
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/service-feedback">Service Details</NavLink>
      </NavItem>
    </Nav>
    <Nav navbar class="ms-auto">
      {#if authenticated}
        <Dropdown nav inNavbar>
          <DropdownToggle nav caret>
            {keycloak.tokenParsed.name || keycloak.tokenParsed.email}
            {team ? `- ${team.name}` : ''}
          </DropdownToggle>
          <DropdownMenu end>
            {#if keycloak.getFirstRole([EventRole.SuperAdmin, EventRole.CTFAdmin])}
              <DropdownItem href="/staff/ctf-dashboard">CTF Dashboard</DropdownItem>
              <DropdownItem href="/staff/ctf">Edit CTF Challenges</DropdownItem>
              <DropdownItem divider />
            {/if}
            {#if keycloak.getFirstRole([EventRole.SuperAdmin, EventRole.EventAdmin])}
              <DropdownItem href="/admin/teams"><i class="fa fa-user-plus" /> Edit Teams</DropdownItem>
              <DropdownItem href="/admin/event-configuration"><i class="fa fa-server" /> Configure Event</DropdownItem>
              <DropdownItem href="/admin/services"><i class="fa fa-server" /> Edit Checks</DropdownItem>
              <DropdownItem href="/admin/bonuses"><i class="fa fa-star" /> Award/Dock Points</DropdownItem>
              <DropdownItem divider />
            {/if}
            <DropdownItem href="/dashboard">Dashboard</DropdownItem>
            <DropdownItem href="/service-feedback">Service Feedback</DropdownItem>
            <DropdownItem divider />
            <DropdownItem
              class="clickable"
              on:click={() => {
                keycloak.logout();
              }}>Logout</DropdownItem
            >
          </DropdownMenu>
        </Dropdown>
      {:else}
        <NavItem>
          <NavLink href="/login?referer={loginRedirect}">Login</NavLink>
        </NavItem>
      {/if}
    </Nav>
  </Collapse>
</Navbar>
